# coding=utf-8
# --------------------------------------------------------------------------
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.
# --------------------------------------------------------------------------

from msrest.serialization import Model


class AccountsAccountResponseDTO(Model):
    """AccountsAccountResponseDTO.

    :param account_id: The account identifier
    :type account_id: int
    :param account_code: The account code
    :type account_code: str
    :param account_info: The account info
    :type account_info: str
    :param account_type: The type of the account. Examples include billing,
     chargeback and invoicing
    :type account_type: ~energycap.sdk.models.AccountsAccountTypeChildDTO
    :param cost_center: The cost center to which the account belongs
    :type cost_center: ~energycap.sdk.models.CostCentersCostCenterChildDTO
    :param vendor: The account's vendor
    :type vendor: ~energycap.sdk.models.VendorsVendorChildDTO
    :param contact: The contact person for the account
    :type contact: ~energycap.sdk.models.AccountsContactChildDTO
    :param customer: The customer the account serves. This value is only set
     for chargeback accounts
    :type customer: ~energycap.sdk.models.AccountsCustomerChildDTO
    :param active: Indicates whether the Account is active or inactive
    :type active: bool
    :param accrual_enabled: Indicates if this account is used with accruals
    :type accrual_enabled: bool
    :param address: The address of the account
    :type address: ~energycap.sdk.models.AccountsAddressChildDTO
    :param deposit_paid: The date and time a deposit was paid
    :type deposit_paid: datetime
    :param deposit_return: The date and time the account deposit was returned
    :type deposit_return: datetime
    :param deposit_note: A note related to the account deposit
    :type deposit_note: str
    :param deposit_amount: The account deposit amount
    :type deposit_amount: float
    :param memo: The account memo
    :type memo: str
    :param service_start: The account's service begin date and time
    :type service_start: datetime
    :param service_end: The account's service end date and time
    :type service_end: datetime
    :param account_general_ledger: The account's general ledger
    :type account_general_ledger:
     ~energycap.sdk.models.BillsGeneralLedgerChildDTO
    :param meters: An array of identifiers for meters attached to this account
    :type meters: list[~energycap.sdk.models.AccountsAccountMeterChildDTO]
    :param created_by: The user who created the account
    :type created_by: ~energycap.sdk.models.UserUserChildDTO
    :param created_date: The date and time the account was created
    :type created_date: datetime
    :param modified_by: The most recent user who modified the account
    :type modified_by: ~energycap.sdk.models.UserUserChildDTO
    :param modified_date: The date and time of the most recent modification
    :type modified_date: datetime
    :param cost_unit: The cost unit
    :type cost_unit: ~energycap.sdk.models.UnitUnitChildDTO
    :param has_calculated_meter: Indicates whether the Account has a child
     calculated meter
    :type has_calculated_meter: bool
    :param has_split_parent_meter: Indicates whether the Account is a
     recipient of a split
    :type has_split_parent_meter: bool
    :param has_split_child_meter: Indicates whether the Account has a child
     split meter
    :type has_split_child_meter: bool
    """

    _attribute_map = {
        'account_id': {'key': 'accountId', 'type': 'int'},
        'account_code': {'key': 'accountCode', 'type': 'str'},
        'account_info': {'key': 'accountInfo', 'type': 'str'},
        'account_type': {'key': 'accountType', 'type': 'AccountsAccountTypeChildDTO'},
        'cost_center': {'key': 'costCenter', 'type': 'CostCentersCostCenterChildDTO'},
        'vendor': {'key': 'vendor', 'type': 'VendorsVendorChildDTO'},
        'contact': {'key': 'contact', 'type': 'AccountsContactChildDTO'},
        'customer': {'key': 'customer', 'type': 'AccountsCustomerChildDTO'},
        'active': {'key': 'active', 'type': 'bool'},
        'accrual_enabled': {'key': 'accrualEnabled', 'type': 'bool'},
        'address': {'key': 'address', 'type': 'AccountsAddressChildDTO'},
        'deposit_paid': {'key': 'depositPaid', 'type': 'iso-8601'},
        'deposit_return': {'key': 'depositReturn', 'type': 'iso-8601'},
        'deposit_note': {'key': 'depositNote', 'type': 'str'},
        'deposit_amount': {'key': 'depositAmount', 'type': 'float'},
        'memo': {'key': 'memo', 'type': 'str'},
        'service_start': {'key': 'serviceStart', 'type': 'iso-8601'},
        'service_end': {'key': 'serviceEnd', 'type': 'iso-8601'},
        'account_general_ledger': {'key': 'accountGeneralLedger', 'type': 'BillsGeneralLedgerChildDTO'},
        'meters': {'key': 'meters', 'type': '[AccountsAccountMeterChildDTO]'},
        'created_by': {'key': 'createdBy', 'type': 'UserUserChildDTO'},
        'created_date': {'key': 'createdDate', 'type': 'iso-8601'},
        'modified_by': {'key': 'modifiedBy', 'type': 'UserUserChildDTO'},
        'modified_date': {'key': 'modifiedDate', 'type': 'iso-8601'},
        'cost_unit': {'key': 'costUnit', 'type': 'UnitUnitChildDTO'},
        'has_calculated_meter': {'key': 'hasCalculatedMeter', 'type': 'bool'},
        'has_split_parent_meter': {'key': 'hasSplitParentMeter', 'type': 'bool'},
        'has_split_child_meter': {'key': 'hasSplitChildMeter', 'type': 'bool'},
    }

    def __init__(self, account_id=None, account_code=None, account_info=None, account_type=None, cost_center=None, vendor=None, contact=None, customer=None, active=None, accrual_enabled=None, address=None, deposit_paid=None, deposit_return=None, deposit_note=None, deposit_amount=None, memo=None, service_start=None, service_end=None, account_general_ledger=None, meters=None, created_by=None, created_date=None, modified_by=None, modified_date=None, cost_unit=None, has_calculated_meter=None, has_split_parent_meter=None, has_split_child_meter=None):
        super(AccountsAccountResponseDTO, self).__init__()
        self.account_id = account_id
        self.account_code = account_code
        self.account_info = account_info
        self.account_type = account_type
        self.cost_center = cost_center
        self.vendor = vendor
        self.contact = contact
        self.customer = customer
        self.active = active
        self.accrual_enabled = accrual_enabled
        self.address = address
        self.deposit_paid = deposit_paid
        self.deposit_return = deposit_return
        self.deposit_note = deposit_note
        self.deposit_amount = deposit_amount
        self.memo = memo
        self.service_start = service_start
        self.service_end = service_end
        self.account_general_ledger = account_general_ledger
        self.meters = meters
        self.created_by = created_by
        self.created_date = created_date
        self.modified_by = modified_by
        self.modified_date = modified_date
        self.cost_unit = cost_unit
        self.has_calculated_meter = has_calculated_meter
        self.has_split_parent_meter = has_split_parent_meter
        self.has_split_child_meter = has_split_child_meter
